#include "forms.h"
#include "playlist.h"
#include "main_panel.h"
#include "play.h"
#include "engine.h"

/* fileselector callbacks */

int add_selector_callback(const char * filename, void * data)
{
	fl_addto_browser(list->list_browser, filename);
	list->updated = 1;
}


/* callbacks for form playlist */

void done_button_callback(FL_OBJECT * ob, long data)
{
	list->active = 0;
	fl_hide_form(list->playlist);
	fl_set_button(panel->list_button, 0);
	if ( list->updated )
	{
		refresh();
		list->updated = 0;
	}
}

void add_button_callback(FL_OBJECT * ob, long data)
{
	const char * buf;

	fl_set_fselector_callback(add_selector_callback, NULL);
	fl_show_fselector("Choose a File", config->module_dir, "*","");
}

void remove_buton_callback(FL_OBJECT * ob, long data)
{
	int	i, l;
	
	l = fl_get_browser_maxline(list->list_browser);
	for ( i=1 ; i<=l ; i++ )
		if ( fl_isselected_browser_line(list->list_browser, i) )
		{ 
			fl_delete_browser_line(list->list_browser, i);
			i--;
			l--;
			list->updated = 1;
		}
}

void load_buton_callback(FL_OBJECT * ob, long data)
{
	const char	* buf;
	FILE		* f;
	
	buf = fl_show_fselector("Playlist name : ", config->playlist_dir, "*.lst", "");
	if ( buf != NULL )
	{
		fl_freeze_form(list->playlist);
		fl_clear_browser(list->list_browser);
		fl_set_object_label(list->list_text, buf);
		load_list(buf);
		fl_unfreeze_form(list->playlist);
	}
	list->updated = 1;
}

void save_button_callback(FL_OBJECT * ob, long data)
{
	const char	* buf;
	FILE		* f;
	int		i;
	
	buf = fl_show_fselector("Playlist name : ", config->playlist_dir, "*.lst", "");
	if ( buf != NULL )
	{
		f = fopen(buf, "w");
		if ( f == NULL )
		{
			printf("Cannot open playlist file %s\n", buf);
			return;
		}
		for ( i=1 ; i<=fl_get_browser_maxline(list->list_browser) ; i++ )
			fprintf(f, "%s\n",fl_get_browser_line(list->list_browser, i) );
		fclose(f);
		fl_set_object_label(list->list_text, buf);
	}
}

void list_browser_callback(FL_OBJECT * ob, long data)
{
	printf("List callback with data %d \n", data);
}
